#include "eqmixer.h"

int main(int argc, char ** argv) {

    Fl_Window *main_window = new Fl_Window(720, 205, "Equinox Sound Mixer");
     main_window->label_type(FL_NO_LABEL);
    
    Fl_Menu_Bar *vc_menubar = new Fl_Menu_Bar(0, 0, 720, 25);
     vc_menubar->begin();
    Fl_Item_Group file("&File");
          Fl_Item* quit_item = new Fl_Item("Quit");
                   quit_item->shortcut(FL_ALT+'Q');
		   quit_item->callback(quit_cb);
    file.end();

    Fl_Item_Group help("&Help");
	  Fl_Item* about_item = new Fl_Item("About");
                   about_item->shortcut(FL_ALT+'A');
		   about_item->callback(about_volume_control);
    help.end();
    vc_menubar->end();

     
    volume_slider = new Fl_Slider(20, 50, 20, 80, "VOL");
                default_look(volume_slider);
        volume_balance = new Fl_Slider(10, 135, 40, 15, "Balance");
		default_look_b(volume_balance);
        volume_mute = new Fl_Check_Button(5, 165, 20, 20, "Mute");
		volume_mute->align(FL_ALIGN_BOTTOM);
        volume_rec = new Fl_Check_Button(35, 165, 20, 20, "Rec");
    	        volume_rec->align(FL_ALIGN_BOTTOM);
		    
		    
    cd_slider = new Fl_Slider(80, 50, 20, 80, "CD");
                default_look(cd_slider);
	cd_balance = new Fl_Slider(70, 135, 40, 15, "Balance");
		default_look_b(cd_balance);
	cd_mute = new Fl_Check_Button(65, 165, 20, 20, "Mute");
		cd_mute->align(FL_ALIGN_BOTTOM);
	cd_rec = new Fl_Check_Button(95, 165, 20, 20, "Rec");
	        cd_rec->align(FL_ALIGN_BOTTOM);

     
    pcm_slider = new Fl_Slider(140, 50, 20, 80, "PCM");
	         default_look(pcm_slider);
    pcm_balance = new Fl_Slider(130, 135, 40, 15, "Balance");
		default_look_b(pcm_balance);
    pcm_mute = new Fl_Check_Button(125, 165, 20, 20, "Mute");
      pcm_mute->align(FL_ALIGN_BOTTOM);
    pcm_rec = new Fl_Check_Button(155, 165, 20, 20, "Rec");
     pcm_rec->align(FL_ALIGN_BOTTOM);
      
           
    synth_slider = new Fl_Slider(200, 50, 20, 80, "SYNTH");
                   default_look(synth_slider);
    synth_balance = new Fl_Slider(190, 135, 40, 15, "Balance");
		   default_look_b(synth_balance);
    synth_mute = new Fl_Check_Button(185, 165, 20, 20, "Mute");
                   synth_mute->align(FL_ALIGN_BOTTOM);
    synth_rec = new Fl_Check_Button(215, 165, 20, 20, "Rec");
                   synth_rec->align(FL_ALIGN_BOTTOM);
   
		   
     
    line_slider = new Fl_Slider(260, 50, 20, 80, "LINE");
                  default_look(line_slider);
    line_balance = new Fl_Slider(250, 135, 40, 15, "Balance");
		default_look_b(line_balance);
    line_mute = new Fl_Check_Button(245, 165, 20, 20, "Mute");
                   line_mute->align(FL_ALIGN_BOTTOM);
    line_rec = new Fl_Check_Button(275, 165, 20, 20, "Rec");
                   line_rec->align(FL_ALIGN_BOTTOM);
		  
     
    bass_slider = new Fl_Slider(320, 50, 20, 80, "BASS");
                  default_look(bass_slider);
    bass_balance = new Fl_Slider(310, 135, 40, 15, "Balance");
		  default_look_b(bass_balance);
    bass_mute = new Fl_Check_Button(305, 165, 20, 20, "Mute");
                  bass_mute->align(FL_ALIGN_BOTTOM);
    bass_rec = new Fl_Check_Button(335, 165, 20, 20, "Rec");
                  bass_rec->align(FL_ALIGN_BOTTOM);
		  
      
    treble_slider = new Fl_Slider(380, 50, 20, 80, "TREBLE");
                    default_look(treble_slider);
    treble_balance = new Fl_Slider(370, 135, 40, 15, "Balance");
                  default_look_b(treble_balance);
    treble_mute = new Fl_Check_Button(365, 165, 20, 20, "Mute");
      treble_mute->align(FL_ALIGN_BOTTOM);
    treble_rec = new Fl_Check_Button(395, 165, 20, 20, "Rec");
      treble_rec->align(FL_ALIGN_BOTTOM);
		    
     
    mic_slider = new Fl_Slider(440, 50, 20, 80, "MIC");
                 default_look(mic_slider);
    mic_balance = new Fl_Slider(430, 135, 40, 15, "Balance");
		default_look_b(mic_balance);
    mic_mute = new Fl_Check_Button(425, 165, 20, 20, "Mute");
                 mic_mute->align(FL_ALIGN_BOTTOM);
    mic_rec = new Fl_Check_Button(455, 165, 20, 20, "Rec");
                 mic_rec->align(FL_ALIGN_BOTTOM);
		 
     
    speaker_slider = new Fl_Slider(500, 50, 20, 80, "SPK");
                     default_look(speaker_slider);
    speaker_balance = new Fl_Slider(490, 135, 40, 15, "Balance");
         	     default_look_b(speaker_balance);
    speaker_mute = new Fl_Check_Button(485, 165, 20, 20, "Mute");
                     speaker_mute->align(FL_ALIGN_BOTTOM);
    speaker_rec = new Fl_Check_Button(515, 165, 20, 20, "Rec");
                    speaker_rec->align(FL_ALIGN_BOTTOM);
		     
     
    imix_slider = new Fl_Slider(560, 50, 20, 80, "IMIX");
	          default_look(imix_slider);
    imix_balance = new Fl_Slider(550, 135, 40, 15, "Balance");
                  default_look_b(imix_balance);
    imix_mute = new Fl_Check_Button(545, 165, 20, 20, "Mute");
                  imix_mute->align(FL_ALIGN_BOTTOM);
    imix_rec = new Fl_Check_Button(575, 165, 20, 20, "Rec");
                  imix_rec->align(FL_ALIGN_BOTTOM);
		  
    
    igain_slider = new Fl_Slider(620, 50, 20, 80, "IGAIN");
    	           default_look(igain_slider);
    igain_balance = new Fl_Slider(610, 135, 40, 15, "Balance");
    		   default_look_b(igain_balance);
    igain_mute = new Fl_Check_Button(605, 165, 20, 20, "Mute");
                   igain_mute->align(FL_ALIGN_BOTTOM);
    igain_rec = new Fl_Check_Button(635, 165, 20, 20, "Rec");
                   igain_rec->align(FL_ALIGN_BOTTOM);
		   
    
    ogain_slider = new Fl_Slider(680, 50, 20, 80, "OGAIN");
    	           default_look(ogain_slider);
    ogain_balance = new Fl_Slider(670, 135, 40, 15, "Balance");
		   default_look_b(ogain_balance);
    ogain_mute = new Fl_Check_Button(665, 165, 20, 20, "Mute");
	           ogain_mute->align(FL_ALIGN_BOTTOM);
    ogain_rec = new Fl_Check_Button(695, 165, 20, 20, "Rec");
		   ogain_rec->align(FL_ALIGN_BOTTOM);
		   
    mixer_device = open(device, O_RDWR);
    
    if (mixer_device == -1) { 
	mixer_device = open(old_device, O_RDWR);
	if (mixer_device == -1) { 
    	    fl_alert("Failed opening mixer device: %s", device);
	    volume_slider->deactivate(); cd_slider->deactivate();
	    pcm_slider->deactivate(); synth_slider->deactivate();
	    line_slider->deactivate(); bass_slider->deactivate();
	    treble_slider->deactivate(); mic_slider->deactivate();
    	    speaker_slider->deactivate(); imix_slider->deactivate();
	    igain_slider->deactivate(); ogain_slider->deactivate();
	}
    }

    volume_slider->callback( (Fl_Callback*) cb_volume, (void*) 1 );
    volume_balance->callback( (Fl_Callback*) cb_volume,(void *) 2 );    
    volume_mute->callback( (Fl_Callback*) cb_volume,(void *) 3 );    
    volume_rec->callback( (Fl_Callback*) cb_volume,(void *) 4 );
    get_device_info(mixer_device, volume_slider, volume_balance, volume_rec, SOUND_MIXER_VOLUME);    
    
    cd_slider->callback( (Fl_Callback*) cb_cd, (void *) 1 );
    cd_balance->callback( (Fl_Callback*) cb_cd,(void *) 2 );    
    cd_mute->callback( (Fl_Callback*) cb_cd,(void *) 3 );    
    cd_rec->callback( (Fl_Callback*) cb_cd,(void *) 4 );
    get_device_info(mixer_device, cd_slider, cd_balance, cd_rec, SOUND_MIXER_CD);

    pcm_slider->callback( (Fl_Callback*) cb_pcm, (void *) 1 );
    pcm_balance->callback( (Fl_Callback*) cb_pcm,(void *) 2 );    
    pcm_mute->callback( (Fl_Callback*) cb_pcm,(void *) 3 );    
    pcm_rec->callback( (Fl_Callback*) cb_pcm,(void *) 4 );
    get_device_info(mixer_device, pcm_slider, pcm_balance, pcm_rec, SOUND_MIXER_PCM);

    synth_slider->callback( (Fl_Callback*) cb_synth, (void *) 1 );
    synth_balance->callback( (Fl_Callback*) cb_synth,(void *) 2 );    
    synth_mute->callback( (Fl_Callback*) cb_synth,(void *) 3 );    
    synth_rec->callback( (Fl_Callback*) cb_synth,(void *) 4 );
    get_device_info(mixer_device, synth_slider, synth_balance, synth_rec, SOUND_MIXER_SYNTH);    
    
    line_slider->callback( (Fl_Callback*) cb_line, (void *) 1 );
    line_balance->callback( (Fl_Callback*) cb_line,(void *) 2 );    
    line_mute->callback( (Fl_Callback*) cb_line,(void *) 3 );    
    line_rec->callback( (Fl_Callback*) cb_line,(void *) 4 );
    get_device_info(mixer_device, line_slider, line_balance, line_rec, SOUND_MIXER_LINE);    
    
    bass_slider->callback( (Fl_Callback*) cb_bass, (void *) 1 );
    bass_balance->callback( (Fl_Callback*) cb_bass,(void *) 2 );    
    bass_mute->callback( (Fl_Callback*) cb_bass,(void *) 3 );    
    bass_rec->callback( (Fl_Callback*) cb_bass,(void *) 4 );
    get_device_info(mixer_device, bass_slider, bass_balance, bass_rec, SOUND_MIXER_BASS);    
     
    treble_slider->callback( (Fl_Callback*) cb_treble, (void *) 1 );
    treble_balance->callback( (Fl_Callback*) cb_treble,(void *) 2 );    
    treble_mute->callback( (Fl_Callback*) cb_treble,(void *) 3 );    
    treble_rec->callback( (Fl_Callback*) cb_treble,(void *) 4 );
    get_device_info(mixer_device, treble_slider, treble_balance, treble_rec, SOUND_MIXER_TREBLE);    
    
    mic_slider->callback( (Fl_Callback*) cb_mic, (void *) 1 );
    mic_balance->callback( (Fl_Callback*) cb_mic,(void *) 2 );    
    mic_mute->callback( (Fl_Callback*) cb_mic,(void *) 3 );    
    mic_rec->callback( (Fl_Callback*) cb_mic,(void *) 4 );
    get_device_info(mixer_device, mic_slider, mic_balance, mic_rec, SOUND_MIXER_MIC);    
     
    speaker_slider->callback( (Fl_Callback*) cb_speaker, (void *) 1 );
    speaker_balance->callback( (Fl_Callback*) cb_speaker,(void *) 2 );    
    speaker_mute->callback( (Fl_Callback*) cb_speaker,(void *) 3 );    
    speaker_rec->callback( (Fl_Callback*) cb_speaker,(void *) 4 );
    get_device_info(mixer_device, speaker_slider, speaker_balance, speaker_rec, SOUND_MIXER_SPEAKER);    
     
    imix_slider->callback( (Fl_Callback*) cb_imix, (void *) 1 );
    imix_balance->callback( (Fl_Callback*) cb_imix,(void *) 2 );    
    imix_mute->callback( (Fl_Callback*) cb_imix,(void *) 3 );    
    imix_rec->callback( (Fl_Callback*) cb_imix,(void *) 4 );
    get_device_info(mixer_device, imix_slider, imix_balance, imix_rec, SOUND_MIXER_IMIX);    
    
    igain_slider->callback( (Fl_Callback*) cb_igain, (void *) 1 );
    igain_balance->callback( (Fl_Callback*) cb_igain,(void *) 2 );    
    igain_mute->callback( (Fl_Callback*) cb_igain,(void *) 3 );    
    igain_rec->callback( (Fl_Callback*) cb_igain,(void *) 4 );
    get_device_info(mixer_device, igain_slider, igain_balance, igain_rec, SOUND_MIXER_IGAIN);    
	       
    ogain_slider->callback( (Fl_Callback*) cb_ogain, (void *) 1 );
    ogain_balance->callback( (Fl_Callback*) cb_ogain,(void *) 2 );    
    ogain_mute->callback( (Fl_Callback*) cb_ogain,(void *) 3 );    
    ogain_rec->callback( (Fl_Callback*) cb_ogain,(void *) 4 );
    get_device_info(mixer_device, ogain_slider, ogain_balance, ogain_rec, SOUND_MIXER_OGAIN);    

// ****************************** END ACTIONS ******************************

    main_window->end();
    main_window->show(argc, argv);

    return Fl::run();
}




void cb_ok(Fl_Widget *w, Fl_Window *window) {
    window->hide(); 
}


void about_volume_control(Fl_Widget*, void*) {
    fl_message("Mixer for Equinox Desktop Environment\n(c) 2000-2001, Martin Pekar\nv. 0.3\n");
}

