#ifndef __ZZLIST_H__
#define __ZZLIST_H__

#include <qlistbox.h> 
#include <qpainter.h> 
#include <qcolor.h>


class  ZZlistItem: public QListBoxItem
{
public:
  ZZlistItem( const char*s)
	: QListBoxItem(), isActive(false)
	{ setText( s ); }
  void setActive()
	{ isActive=true; }
  void setUnActive()
	{ isActive=false; }

protected:
  virtual void paint( QPainter * );
  virtual int height( const QListBox * ) const;
  virtual int width( const QListBox * ) const;
private:
  bool isActive;
};

void ZZlistItem::paint( QPainter *p )
{
  QFontMetrics fm = p->fontMetrics();
  if (isActive)
	p->setPen( red );
  p->drawText( 6, fm.ascent() + fm.leading()/2, text() );
}

int ZZlistItem::height(const QListBox *lb ) const
{
  return lb->fontMetrics().lineSpacing() + 1 ;
}

int ZZlistItem::width(const QListBox *lb ) const
{
  return lb->fontMetrics().width( text() ) + 1;
}

#endif
