//============================================================================
//
//	ZZplayer : MPEG-I video player
// 	Copyright (C) 1999 Nicolas Vignal <nicolas.vignal@fnac.net
//  Home    : http://www.chez.com/tsc/zzplayer/zzplayer.html
//
//	Requires the Qt widget libraries, available at no cost at
//      http://www.troll.no
//
//  File    : playlist.h
//  Author  : Frederic Grasset
//  E-Mail  : frederic.grasset@wanadoo.fr

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//============================================================================

#ifndef __PLAYLIST_H__
#define __PLAYLIST_H__

#include <stdio.h>

#include <kapp.h>
#include <kfiledialog.h>
#include <kmsgbox.h>
#include <kfm.h>
#include <kurl.h>
#include <drag.h>

#include <qlayout.h>
#include <qcombobox.h>
#include <qlist.h>
#include <qlistbox.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qframe.h>
#include <qbuttongroup.h>
#include <qpushbutton.h>
#include <qmessagebox.h>
#include <qfile.h>
#include <qtextstream.h>

#include "zzoptions.h"
#include "../../plugins/Plugin.h"

class ZZplaylist : public QWidget
{
  Q_OBJECT

// the true playlist will be a object
// so the GUI playlist can manipulate many playlists
	QList<QString>  list;
	int	currentpos;

//	QComboBox	*titre;
	QListBox *pList;

public:
	ZZplaylist();
	~ZZplaylist();

	bool addList( QStrList &lst, bool rec=false, bool newList=false );
	bool addFile( QString &file, bool rec=false, bool newList=false );
	QString *firstFile();
	QString *lastFile();
	QString *nextFile();
	QString *prevFile();
	QString *currentFile();

signals:
	void removeCurrentTitle();
	void selectTitle();
	void dropAction(KDNDDropZone *);

private slots:

	void slotNewList();
	void slotLoadList();
	void slotSaveList();
	void slotAddList();
	void slotAddFile();
	void slotRmFile();
	void slotMoveUp();
	void slotMoveDown();
	void slotClosePlaylist();
	void slotSelectFile(int index);
	void slotDropAction(KDNDDropZone *url);

private: // Private methods

	QString *get_file_name(QString &file);
	void addString(QString &str);
	void swapFile(int p1, int p2);
	void setCurrent(int pos);
};



#endif
