//============================================================================
//
//	ZZplayer : MPEG-I video player
// 	Copyright (C) 1999 Nicolas Vignal <nicolas.vignal@fnac.net
//  Home    : http://www.chez.com/tsc/zzplayer/zzplayer.html
//
//	Requires the Qt widget libraries, available at no cost at
//      http://www.troll.no
//
//  File    : dialogBox.h
//  Author  : Frederic Grasset
//  E-Mail  : frederic.grasset@wanadoo.fr

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//============================================================================

#ifndef __DIALOGBOX_H__
#define __DIALOGBOX_H__

#include <stdio.h>

#include <kapp.h>

#include <qtabdialog.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qgroupbox.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qlineedit.h>


#define INFO_MESSAGE "ZZplayer "##VERSION"\n\n"\
"Copyright (c) 1999 Nicolas Vignal <nicolas.vignal@fnac.net>\n\n"\
"This program is free software; you can redistribute it\nand/or modify"\
" it under the terms of the GNU General Public\nLicense as"\
" published by"\
" the Free Software Foundation; either\nversion 2 "\
"of the License, or (at your option) any later version.\n\n"\
"The program is distributed in hopes that it will be useful,\n"\
"but WITHOUT ANY WARRANTY; without even the implied\nwarranty of"\
" MERCHANTABILITY or FITNESS FOR A\n"\
"PARTICULAR PURPOSE. See the GNU General Public\n"\
"License for more details.\n\n"\
"You should have received a copy of the GNU General\nPublic License along"\
" with this program.  If not, write\nto the Free Software Foundation, Inc.,"\
" 675 Mass Ave,\n"\
"Cambridge, MA 02139, USA."


#include "zzoptions.h"

class dialogBox : public QTabDialog
{
  Q_OBJECT

// OK, the name of this vas are the same of the zzplayer object, and that's bad, but...
	ZZoptions	*p;

	QCheckBox	*fullScreenOnOpen;
	QCheckBox	*keepResolution;
	QCheckBox	*keepRatio;
	QCheckBox	*closeOnEnd;
	QCheckBox	*saveOnExit;
	
	QCheckBox	*popupOnClick;
	
	QLineEdit	*Device;

	QCheckBox	*multipleInstance;
	QCheckBox	*bilinearFilter;

public:
	dialogBox(ZZoptions *opt);
	~dialogBox();

signals:
	void applyOptions();
	void saveOpt();

private slots:
	void saveNow();
	void applyAction();
private: // Private methods
  /** Create the first tab
for use in the constructor only */
  QWidget * first_tab(QWidget *parent);
  /** Create the second tab
for use in the constructor only */
  QWidget * second_tab ( QWidget *parent );
  /** Create the third tab
for use in the constructor only */
	QWidget * third_tab ( QWidget *parent );
};



#endif
