//============================================================================
//
//	ZZplayer : MPEG-I video player
// 	Copyright (C) 1999 Nicolas Vignal <nicolas.vignal@fnac.net
//
//  Author  : Nicolas Vignal
//  E-Mail  : nicolas.vignal@fnac.net
//  Home    : http://zzplayer.sourceforge.net

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//============================================================================

#include "VirtualMpeg.h"
#include <SDL_thread.h>

#ifndef MPEGVCD_H
#define MPEGVCD_H

#if defined (__linux)
#define IS_CDROM_DEV(dev) (S_ISBLK(dev))
#elif defined (__sun)
#define IS_CDROM_DEV(dev) (S_ISCHR(dev))
#else
#error Unknown architecture (only linux and solaris known of...)
#endif

class MpegVCD : public VirtualMpeg
{

private :
  int vcdfd;
  SDL_Thread *fillThread;

public :
	
  MpegVCD(const char *vcd, int withaudio, int withvideo, int windowID, int (*eventcallback)(ZZ_EventStruct *));
  ~MpegVCD();
	
  int vcd_open(const char * arg);
  void pause(void);
  void getInfo( int * seek, double *fps, int *frame);
  void setSeek(int seek);

};

#endif
