//============================================================================
//
//	ZZplayer : MPEG-I video player
// 	Copyright (C) 1999 Nicolas Vignal <nicolas.vignal@fnac.net
//
//  Author  : Nicolas Vignal
//  E-Mail  : nicolas.vignal@fnac.net
//  Home    : http://zzplayer.sourceforge.net

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//============================================================================

#ifndef VIRTUALMPEG_H
#define VIRTUALMPEG_H

#include "../Plugin.h"
#include "SDL.h"
#include <smpeg/smpeg.h>
#include "SDL_thread.h"

extern "C" {
 SDL_Surface *IMG_LoadXPM_RW(SDL_RWops *src);
}
	
class VirtualMpeg : public Plugin
{

protected:	
	
	SMPEG* mpeg;
 	SMPEG_Info info;
 	SDL_Thread *thread;
 	SDL_sem *lockScreen;
        int quit;
 	SDL_Surface* sdl_screen;
 	int keepThisResolution;
 	int keepRatio;
 	
	int SDLaudio;
	int SDLvideo;
	
	// dirty
	int lastwidth;
	int lastheight;
	
  int (*eventCallBack)( ZZ_EventStruct *);
	
public :
	VirtualMpeg(int withaudio, int withvideo, int windowID,int (*eventcallback)(ZZ_EventStruct *));
	virtual ~VirtualMpeg();

virtual	void pause(void)=0;
virtual	void getInfo( int * seek, double *fps, int *frame)=0;
virtual	void setSeek(int seek)=0;
	
	
  int  checkVideoEvents(void);
	void clearScreen(void);
	void fullScreen(int state);
	void getFullInfo(StreamInfo *streamInfo);
	void killEventThread(void);
	void setBilinearFilter(int bilinearfilter);
	void setKeepThisResolution(int keepthisresolution);
	void setKeepRatio(int keepratio);
	void setVolume(int volume);
	int  status(void);
	void startEventThread(void);
	char *error(void);
	
	int  hasSound(void);
	void getResolution(int *xsize, int *ysize, int *depth);
	void initVideo(int fullscreen);
	void lockVideo(void);
	void unlockVideo(void);
	void setTitle(const char* title);
};

#endif
